////////////////////////////////////////////////////////
////                 Przykad 8.                    ////
//// Parametry ruchu ruch absolutny i inkrementalny ////
////         13.04.2015 ukasz Grniak              ////
////////////////////////////////////////////////////////


//Definicje etykiet

#PRZYSPIESZANIE     200
#HAMOWANIE          100
#PREDKOSC           300

#START              IN3
#NASTEPNY_PUNKT     IN1
#PRZYSPIESZ         IN2

#DIODA_1            OUT1
#DIODA_2            OUT2



CFGINT_IN7 = RIS //Konfiguracja przerwania - wejcie IN7 - STOP AWARYJNY  
CFGINT_IN4 = RIS //Konfiguracja przerwania - wejcie IN4 - Zatrzymanie napdu M3  

//Ustawienie parametrw rampy dla napdow M1, M2
AccM1 = PRZYSPIESZANIE
AccM2 = PRZYSPIESZANIE
AccM3 = PRZYSPIESZANIE

DecM1 = HAMOWANIE
DecM2 = HAMOWANIE

VmaxM1 = PREDKOSC
VmaxM2 = PREDKOSC


WAIT START=1   // Oczekiwanie na wciniecie przycisku START (IN3)
M1 = ON    //Uruchomienie napdw - Ustawienie sygnau ENABLE
M2 = ON
M3 = ON

HOME M1 -10    //Bazowanie napdu M1 z prdkoci 10 w lew stron 
HOME M2 -10    //Bazowanie napdu M2 z prdkoci 10 w lew stron 
WAITPOS

MAIN:
    

    IF PRZYSPIESZ = ON          //Sprawdzenie stanu przycisku PRZYSPIESZ
       DELAY 0.2
       VREL M3 20               //Jeli przycisk wcinity zwikszenie prdkoci napdu M3 o 10 jednostek
       SET SKOK = SKOK+1        //Zwikszenie zmiennej SKOK kontrolujcej maksymaln prdko 
    ENDIF

    
    IF SKOK=10                  //Jeli prdko zbyt dua   
        STOP M3 0               //Zatrzymanie napdu M3
        VABS M3 0               //Ustawienie prdkoci absolutnej napdu M3 na 0
        WAIT VactM3 = 0         //Oczekiwanie na Zatrzymanie napdu M3
        SKOK = 0
    ENDIF
    
    IF NASTEPNY_PUNKT=ON        //Sprawdzenie stanu przycisku NASTPNY_PUNKT
        SET LICZBA = LICZBA + 1 //Przejciedo kolejnego punktu 
    ENDIF
    
    IF LICZBA = 1
        DIODA_1=0           //Diody informujce o aktualnej pozycji
        DIODA_2=0
        PABS M1  100        //Zadanie pozycji absolutnej dla napdw M1, M2
        PABS M2  100
        WAITPOS
    ENDIF
    
    IF LICZBA = 2
        DIODA_1=1           //Diody informujce o aktualnej pozycji
        DIODA_2=0
        PREL M1  7          //Zadanie pozycji relatywnej dla napdw M1, M2
        PREL M2  7
        WAITPOS
       SET LICZBA = LICZBA + 1
    ENDIF
    
    IF LICZBA = 4
        DIODA_1=1          //Diody informujce o aktualnej pozycji
        DIODA_2=1
        MOVEPTP @POZYCJA_1 //Zadanie pozycji z tablicy  pod nazw POZYCJA_1
        WAITPOS
    ENDIF
    
    IF LICZBA = 5
        DIODA_1=0          //Diody informujce o aktualnej pozycji
        DIODA_2=1
        LICZBA=0
        MOVEPTP 1          //Zadanie pozycji z tablicy  pod numerem 1
        WAITPOS
    ENDIF

JUMP MAIN

INT_IN4:
    BRAKE M3
RETURN


INT_IN7:                //Przerwanie STOP AWARYJNY
    STOP M1             //Zatrzymanie napdw
    STOP M2
    STOP M3

    M1 = OFF        //Wyczenie napdw
    M2 = OFF
    M3 = OFF

    WAIT IN7=OFF       //Oczekiwanie na wyciniecie stopu awaryjnego

    //Zerowanie warunkw pocztkowych
    LICZBA = 0
    VABS M3 0          //Ustawienie prdkoci absolutnej napdu M3 na 0
    SKOK = 0

    //Reset programu
    PROGRESET          

RETURN